CatPeri <-
function (MyData,binsPerHr, minsPerBin=1, export=FALSE, noise, fileoutP, Hx, cex, Rverbose=0,Debug=FALSE){
  #myData is a vector, not a matrix
  # dt in units of hours
  #source('~/Documents/Cathy/Neuroscience papers/capstone/Chronobiology/CosinorR/CosinorEQ/periCosinor.R') 
# Use the periodogram
  if (.Platform$file.sep=="/"){
    m=regexec("[^/]*$",fileoutP)            #     mac=[^/]*$
  } else {
    m=regexec("[^\\]*$",fileoutP)           #./(.$)    pc=[^\\]*$
  }
  fileName1<-regmatches(fileoutP,m)
peri=periCosinor(MyData,plot=FALSE)
#--par(mfrow=c(3,1))
#print(peri$peri)
n<-length(MyData)
nfft<-(n/2)+1
#print(peri$c)
#print(peri$f)
#print(peri$amp)
#print(1/(peri$c[2:nfft]*dt))
#print(dt)
#plot(peri$f,peri$peri,ylab='Periodogram',xlab='Frequency (radians)',type='h',xaxp=c(0,pi,4))
#------------------------
  periX<-1/peri$c[2:nfft]
  periLastX<-1/peri$c[nfft]
  periY<-peri$peri[2:nfft]
maxLineN<-which.max(peri$peri)
maxLine<-max(peri$peri)
#yLim<-c(NULL,NULL)
if (noise>maxLine){
  plot(periX,periY,ylab='Power',xlab='',ylim=c(0,noise) ,type='h') 
  maxLine<-noise
} else {
#plot(1/(peri$c[2:nfft]*dt),peri$peri[2:nfft],ylab='Periodogram',xlab='Frequency (in radians/cycle)',type='h')
  plot(periX,periY,ylab='Power',xlab='', type='h') 
}
xLast<-length(periX)
title(sub = paste("Frequency (in #",minsPerBin,"-min bins/cycle)", sep=""),line=2)
abline(h=noise,col="grey",lty="dotted")
text(periX[xLast],noise,paste("noise=\n",format(noise,digits=5)), pos=2, cex=cex-.2)

h<-maxLine*.8
lf<-h*Hx*.5       # used to be .7   (minimum .4)
s<-periLastX
text(.5*s,h+(2*lf),"Spectral lines of four largest amplitudes",cex.main=.9)
if (export==T){
  text(.5*s,h+(1.2*lf),paste("See data file",fileName1), cex=cex-.1)
}
if (Rverbose==-1){
  text(c(.41*s,.61*s),c(h,h,h,h,h),labels=c("Period in #hrs","Period in #Bins"),adj = c(0,0), cex=cex)
  h<-h-(lf)
  text(c(.42*s,.62*s),c(h,h,h,h,h),labels=c("---------","----------"),adj = c(0,0), cex=cex)
} else {
  text(c(.11*s,.21*s,.41*s,.61*s,.81*s),c(h,h,h,h,h),labels=c("Line#","Frequency","Period in #hrs","Period in #Bins","Amplitude / Power"),adj = c(0,0), cex=cex)
  h<-h-(lf)
  text(c(.11*s,.21*s,.42*s,.62*s,.81*s),c(h,h,h,h,h),labels=c("----","--------","---------","----------"," ----------"),adj = c(0,0), cex=cex)
  }

if (export==T){
  write.matrix(rbind(cbind("peri","freq","cycle","amp","phase"),cbind(peri$peri,peri$f,peri$c,peri$amp,peri$phase)), file = fileoutP, sep = "\t")
}

binPeaks<-rev(sort(peri$peri))
maxLineN1<-which(peri$peri==binPeaks[1])
maxLineN2<-which(peri$peri==binPeaks[2])
maxLineN3<-which(peri$peri==binPeaks[3])
maxLineN4<-which(peri$peri==binPeaks[4])

if (Rverbose==0){
  h<-h-lf
  text(c(.43*s,.63*s),c(h,h,h,h,h),labels=c(format(peri$c[maxLineN1]/binsPerHr,digits=7),format(peri$c[maxLineN1],digits=7)),adj = c(0,0), cex=cex)
  h<-h-lf       
  text(c(.43*s,.63*s),c(h,h,h,h,h),labels=c(format(peri$c[maxLineN2]/binsPerHr,digits=7),format(peri$c[maxLineN2],digits=7)),adj = c(0,0), cex=cex)
  h<-h-lf
  text(c(.43*s,.63*s),c(h,h,h,h,h),labels=c(format(peri$c[maxLineN3]/binsPerHr,digits=7),format(peri$c[maxLineN3],digits=7)),adj = c(0,0), cex=cex)
  h<-h-lf
  text(c(.43*s,.63*s),c(h,h,h,h,h),labels=c(format(peri$c[maxLineN4]/binsPerHr,digits=7),format(peri$c[maxLineN4],digits=7)),adj = c(0,0), cex=cex)
} else if (Rverbose>0){
  h<-h-lf
  text(c(.12*s,.21*s,.43*s,.63*s,.8*s),c(h,h,h,h,h),labels=c(maxLineN1-1,format(1/peri$c[maxLineN1],digits=7),format(peri$c[maxLineN1]/binsPerHr,digits=7),format(peri$c[maxLineN1],digits=7),paste(format(peri$amp[maxLineN1],digits=4),"/",format(peri$peri[maxLineN1],digits=7))),adj = c(0,0), cex=cex)
  h<-h-lf       
  text(c(.12*s,.21*s,.43*s,.63*s,.8*s),c(h,h,h,h,h),labels=c(maxLineN2-1,format(1/peri$c[maxLineN2],digits=7),format(peri$c[maxLineN2]/binsPerHr,digits=7),format(peri$c[maxLineN2],digits=7),paste(format(peri$amp[maxLineN2],digits=4),"/",format(peri$peri[maxLineN2],digits=7))),adj = c(0,0), cex=cex)
  h<-h-lf
  text(c(.12*s,.21*s,.43*s,.63*s,.8*s),c(h,h,h,h,h),labels=c(maxLineN3-1,format(1/peri$c[maxLineN3],digits=7),format(peri$c[maxLineN3]/binsPerHr,digits=7),format(peri$c[maxLineN3],digits=7),paste(format(peri$amp[maxLineN3],digits=4),"/",format(peri$peri[maxLineN3],digits=7))),adj = c(0,0), cex=cex)
  h<-h-lf
  text(c(.12*s,.21*s,.43*s,.63*s,.8*s),c(h,h,h,h,h),labels=c(maxLineN4-1,format(1/peri$c[maxLineN4],digits=7),format(peri$c[maxLineN4]/binsPerHr,digits=7),format(peri$c[maxLineN4],digits=7),paste(format(peri$amp[maxLineN4],digits=4),"/",format(peri$peri[maxLineN4],digits=7))),adj = c(0,0), cex=cex)
}      # Rverbose=-1 will print nothing on the graph
#-------------------
# peri=peri model,f=freq,c=cycles,amp=amplitude,phase=phase
if (Rverbose>1){
  print(peri$amp)
  print(peri$f)
  print(peri$phase)
  print(peri$c)
  print(peri$realpart)        # ~B?
  print(peri$imagpart)        # ~G?
  new<-(peri$phase/pi)*180}
}
